import { PropType } from 'vue';
import { default as ListInputItem } from './ListInputItem';
import { default as ListInputWithHeaderItem } from './ListInputWithHeaderItem';
import { getId } from '../../helper/IdHelper';
import { default as InfoLabelContent } from '../../helper/types/InfoLabelContent';
declare const _default: import('vue').DefineComponent<import('vue').ExtractPropTypes<{
    items: {
        type: PropType<ListInputWithHeaderItem[]>;
        default: () => never[];
    };
    modelValue: {
        type: (StringConstructor | NumberConstructor)[];
        default: () => string;
    };
    canBeEmpty: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * If the ListInput can be empty, this is the text that will be displayed.
     */
    canBeEmptyInputText: {
        type: StringConstructor;
        default: string;
    };
    /**
     * If you want the empty item to be preselected.
     * This setting is only effective if canBeEmpty is active.
     */
    isCanBeEmptyItemPreselect: {
        type: BooleanConstructor;
        default: boolean;
    };
    widthInPx: {
        type: NumberConstructor;
        default: number;
    };
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    label: {
        type: StringConstructor;
        default: () => string;
    };
    id: {
        type: StringConstructor;
        required: true;
    };
    /**
     * preselect by id
     */
    preselect: {
        type: (StringConstructor | NumberConstructor)[];
        default: () => string;
    };
    /**
     * A small question mark icon will appear, which will display the text when you click on it.
     */
    infoLabelContent: {
        type: PropType<undefined | InfoLabelContent>;
        default: undefined;
    };
}>, {
    position: import('vue').Ref<string, string>;
    selectedItem: import('vue').Ref<{
        id: string | number;
        text: string;
        disabled?: boolean | undefined;
        disabledClass?: string | undefined;
    }, ListInputItem | {
        id: string | number;
        text: string;
        disabled?: boolean | undefined;
        disabledClass?: string | undefined;
    }>;
    minWidth: import('vue').ComputedRef<number>;
    getStyle: (minW: number) => string;
    getId: typeof getId;
}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, "update:modelValue"[], "update:modelValue", import('vue').PublicProps, Readonly<import('vue').ExtractPropTypes<{
    items: {
        type: PropType<ListInputWithHeaderItem[]>;
        default: () => never[];
    };
    modelValue: {
        type: (StringConstructor | NumberConstructor)[];
        default: () => string;
    };
    canBeEmpty: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * If the ListInput can be empty, this is the text that will be displayed.
     */
    canBeEmptyInputText: {
        type: StringConstructor;
        default: string;
    };
    /**
     * If you want the empty item to be preselected.
     * This setting is only effective if canBeEmpty is active.
     */
    isCanBeEmptyItemPreselect: {
        type: BooleanConstructor;
        default: boolean;
    };
    widthInPx: {
        type: NumberConstructor;
        default: number;
    };
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    label: {
        type: StringConstructor;
        default: () => string;
    };
    id: {
        type: StringConstructor;
        required: true;
    };
    /**
     * preselect by id
     */
    preselect: {
        type: (StringConstructor | NumberConstructor)[];
        default: () => string;
    };
    /**
     * A small question mark icon will appear, which will display the text when you click on it.
     */
    infoLabelContent: {
        type: PropType<undefined | InfoLabelContent>;
        default: undefined;
    };
}>> & Readonly<{
    "onUpdate:modelValue"?: ((...args: any[]) => any) | undefined;
}>, {
    label: string;
    disabled: boolean;
    infoLabelContent: InfoLabelContent | undefined;
    modelValue: string | number;
    items: ListInputWithHeaderItem[];
    canBeEmpty: boolean;
    isCanBeEmptyItemPreselect: boolean;
    canBeEmptyInputText: string;
    widthInPx: number;
    preselect: string | number;
}, {}, {
    InfoLabel: import('vue').DefineComponent<import('vue').ExtractPropTypes<{
        forId: {
            type: StringConstructor;
            required: true;
        };
        disabled: {
            type: BooleanConstructor;
            default: undefined;
        };
        width: {
            type: NumberConstructor;
            default: number;
        };
        infoLabelContent: {
            type: PropType<undefined | InfoLabelContent>;
            default: undefined;
        };
        classLabel: {
            type: StringConstructor;
            default: string;
        };
        innerClass: {
            type: StringConstructor;
            default: string;
        };
    }>, {
        position: import('vue').Ref<string, string>;
        checkDivVisibility: () => void;
        tooltipDiv: import('vue').Ref<HTMLElement | null, HTMLElement | null>;
        myWidth: import('vue').Ref<number, number>;
    }, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {}, string, import('vue').PublicProps, Readonly<import('vue').ExtractPropTypes<{
        forId: {
            type: StringConstructor;
            required: true;
        };
        disabled: {
            type: BooleanConstructor;
            default: undefined;
        };
        width: {
            type: NumberConstructor;
            default: number;
        };
        infoLabelContent: {
            type: PropType<undefined | InfoLabelContent>;
            default: undefined;
        };
        classLabel: {
            type: StringConstructor;
            default: string;
        };
        innerClass: {
            type: StringConstructor;
            default: string;
        };
    }>> & Readonly<{}>, {
        disabled: boolean;
        width: number;
        infoLabelContent: InfoLabelContent | undefined;
        classLabel: string;
        innerClass: string;
    }, {}, {
        BaseIcon: import('vue').DefineComponent<import('vue').ExtractPropTypes<{
            name: {
                type: StringConstructor;
                required: true;
            };
            iconClass: {
                type: StringConstructor;
                default: string;
            };
            size: {
                type: StringConstructor;
                default: string;
            };
            label: {
                type: StringConstructor;
                default: string;
            };
        }>, {
            isLoaded: import('vue').Ref<any, any>;
        }, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {}, string, import('vue').PublicProps, Readonly<import('vue').ExtractPropTypes<{
            name: {
                type: StringConstructor;
                required: true;
            };
            iconClass: {
                type: StringConstructor;
                default: string;
            };
            size: {
                type: StringConstructor;
                default: string;
            };
            label: {
                type: StringConstructor;
                default: string;
            };
        }>> & Readonly<{}>, {
            label: string;
            size: string;
            iconClass: string;
        }, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
        BaseLabel: import('vue').DefineComponent<import('vue').ExtractPropTypes<{
            forId: {
                type: StringConstructor;
                required: true;
            };
            classStyle: {
                type: StringConstructor;
                default: string;
            };
            disabled: {
                type: BooleanConstructor;
                default: undefined;
            };
        }>, {}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {}, string, import('vue').PublicProps, Readonly<import('vue').ExtractPropTypes<{
            forId: {
                type: StringConstructor;
                required: true;
            };
            classStyle: {
                type: StringConstructor;
                default: string;
            };
            disabled: {
                type: BooleanConstructor;
                default: undefined;
            };
        }>> & Readonly<{}>, {
            disabled: boolean;
            classStyle: string;
        }, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
        Popover: import('vue').DefineComponent<{
            as: {
                type: (ObjectConstructor | StringConstructor)[];
                default: string;
            };
        }, () => import('vue').VNode<import('vue').RendererNode, import('vue').RendererElement, {
            [key: string]: any;
        }>, unknown, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, Record<string, any>, string, import('vue').VNodeProps & import('vue').AllowedComponentProps & import('vue').ComponentCustomProps, Readonly<import('vue').ExtractPropTypes<{
            as: {
                type: (ObjectConstructor | StringConstructor)[];
                default: string;
            };
        }>>, {
            as: string | Record<string, any>;
        }, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
        PopoverButton: import('vue').DefineComponent<{
            as: {
                type: (ObjectConstructor | StringConstructor)[];
                default: string;
            };
            disabled: {
                type: BooleanConstructor[];
                default: boolean;
            };
            id: {
                type: StringConstructor;
                default: null;
            };
        }, () => import('vue').VNode<import('vue').RendererNode, import('vue').RendererElement, {
            [key: string]: any;
        }>, unknown, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, Record<string, any>, string, import('vue').VNodeProps & import('vue').AllowedComponentProps & import('vue').ComponentCustomProps, Readonly<import('vue').ExtractPropTypes<{
            as: {
                type: (ObjectConstructor | StringConstructor)[];
                default: string;
            };
            disabled: {
                type: BooleanConstructor[];
                default: boolean;
            };
            id: {
                type: StringConstructor;
                default: null;
            };
        }>>, {
            id: string;
            as: string | Record<string, any>;
            disabled: boolean;
        }, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
        PopoverPanel: import('vue').DefineComponent<{
            as: {
                type: (ObjectConstructor | StringConstructor)[];
                default: string;
            };
            static: {
                type: BooleanConstructor;
                default: boolean;
            };
            unmount: {
                type: BooleanConstructor;
                default: boolean;
            };
            focus: {
                type: BooleanConstructor;
                default: boolean;
            };
            id: {
                type: StringConstructor;
                default: null;
            };
        }, () => import('vue').VNode<import('vue').RendererNode, import('vue').RendererElement, {
            [key: string]: any;
        }> | import('vue').VNode<import('vue').RendererNode, import('vue').RendererElement, {
            [key: string]: any;
        }>[] | null, unknown, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, Record<string, any>, string, import('vue').VNodeProps & import('vue').AllowedComponentProps & import('vue').ComponentCustomProps, Readonly<import('vue').ExtractPropTypes<{
            as: {
                type: (ObjectConstructor | StringConstructor)[];
                default: string;
            };
            static: {
                type: BooleanConstructor;
                default: boolean;
            };
            unmount: {
                type: BooleanConstructor;
                default: boolean;
            };
            focus: {
                type: BooleanConstructor;
                default: boolean;
            };
            id: {
                type: StringConstructor;
                default: null;
            };
        }>>, {
            focus: boolean;
            id: string;
            as: string | Record<string, any>;
            unmount: boolean;
            static: boolean;
        }, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
    }, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
    Listbox: import('vue').DefineComponent<{
        as: {
            type: (ObjectConstructor | StringConstructor)[];
            default: string;
        };
        disabled: {
            type: BooleanConstructor[];
            default: boolean;
        };
        by: {
            type: (StringConstructor | FunctionConstructor)[];
            default: () => <T>(a: T, z: T) => boolean;
        };
        horizontal: {
            type: BooleanConstructor[];
            default: boolean;
        };
        modelValue: {
            type: PropType<string | number | boolean | object | null>;
            default: undefined;
        };
        defaultValue: {
            type: PropType<string | number | boolean | object | null>;
            default: undefined;
        };
        form: {
            type: StringConstructor;
            optional: boolean;
        };
        name: {
            type: StringConstructor;
            optional: boolean;
        };
        multiple: {
            type: BooleanConstructor[];
            default: boolean;
        };
    }, () => import('vue').VNode<import('vue').RendererNode, import('vue').RendererElement, {
        [key: string]: any;
    }>, unknown, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {
        'update:modelValue': (_value: any) => true;
    }, string, import('vue').VNodeProps & import('vue').AllowedComponentProps & import('vue').ComponentCustomProps, Readonly<import('vue').ExtractPropTypes<{
        as: {
            type: (ObjectConstructor | StringConstructor)[];
            default: string;
        };
        disabled: {
            type: BooleanConstructor[];
            default: boolean;
        };
        by: {
            type: (StringConstructor | FunctionConstructor)[];
            default: () => <T>(a: T, z: T) => boolean;
        };
        horizontal: {
            type: BooleanConstructor[];
            default: boolean;
        };
        modelValue: {
            type: PropType<string | number | boolean | object | null>;
            default: undefined;
        };
        defaultValue: {
            type: PropType<string | number | boolean | object | null>;
            default: undefined;
        };
        form: {
            type: StringConstructor;
            optional: boolean;
        };
        name: {
            type: StringConstructor;
            optional: boolean;
        };
        multiple: {
            type: BooleanConstructor[];
            default: boolean;
        };
    }>> & {
        "onUpdate:modelValue"?: ((_value: any) => any) | undefined;
    }, {
        as: string | Record<string, any>;
        disabled: boolean;
        horizontal: boolean;
        by: string | Function;
        modelValue: string | number | boolean | object | null;
        defaultValue: string | number | boolean | object | null;
        multiple: boolean;
    }, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
    ListboxButton: import('vue').DefineComponent<{
        as: {
            type: (ObjectConstructor | StringConstructor)[];
            default: string;
        };
        id: {
            type: StringConstructor;
            default: null;
        };
    }, () => import('vue').VNode<import('vue').RendererNode, import('vue').RendererElement, {
        [key: string]: any;
    }> | import('vue').VNode<import('vue').RendererNode, import('vue').RendererElement, {
        [key: string]: any;
    }>[] | null, unknown, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, Record<string, any>, string, import('vue').VNodeProps & import('vue').AllowedComponentProps & import('vue').ComponentCustomProps, Readonly<import('vue').ExtractPropTypes<{
        as: {
            type: (ObjectConstructor | StringConstructor)[];
            default: string;
        };
        id: {
            type: StringConstructor;
            default: null;
        };
    }>>, {
        id: string;
        as: string | Record<string, any>;
    }, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
    ListboxOption: import('vue').DefineComponent<{
        as: {
            type: (ObjectConstructor | StringConstructor)[];
            default: string;
        };
        value: {
            type: PropType<string | number | boolean | object | null>;
        };
        disabled: {
            type: BooleanConstructor;
            default: boolean;
        };
        id: {
            type: StringConstructor;
            default: null;
        };
    }, () => import('vue').VNode<import('vue').RendererNode, import('vue').RendererElement, {
        [key: string]: any;
    }> | import('vue').VNode<import('vue').RendererNode, import('vue').RendererElement, {
        [key: string]: any;
    }>[] | null, unknown, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, Record<string, any>, string, import('vue').VNodeProps & import('vue').AllowedComponentProps & import('vue').ComponentCustomProps, Readonly<import('vue').ExtractPropTypes<{
        as: {
            type: (ObjectConstructor | StringConstructor)[];
            default: string;
        };
        value: {
            type: PropType<string | number | boolean | object | null>;
        };
        disabled: {
            type: BooleanConstructor;
            default: boolean;
        };
        id: {
            type: StringConstructor;
            default: null;
        };
    }>>, {
        id: string;
        as: string | Record<string, any>;
        disabled: boolean;
    }, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
    ListboxOptions: import('vue').DefineComponent<{
        as: {
            type: (ObjectConstructor | StringConstructor)[];
            default: string;
        };
        static: {
            type: BooleanConstructor;
            default: boolean;
        };
        unmount: {
            type: BooleanConstructor;
            default: boolean;
        };
        id: {
            type: StringConstructor;
            default: null;
        };
    }, () => import('vue').VNode<import('vue').RendererNode, import('vue').RendererElement, {
        [key: string]: any;
    }> | import('vue').VNode<import('vue').RendererNode, import('vue').RendererElement, {
        [key: string]: any;
    }>[] | null, unknown, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, Record<string, any>, string, import('vue').VNodeProps & import('vue').AllowedComponentProps & import('vue').ComponentCustomProps, Readonly<import('vue').ExtractPropTypes<{
        as: {
            type: (ObjectConstructor | StringConstructor)[];
            default: string;
        };
        static: {
            type: BooleanConstructor;
            default: boolean;
        };
        unmount: {
            type: BooleanConstructor;
            default: boolean;
        };
        id: {
            type: StringConstructor;
            default: null;
        };
    }>>, {
        id: string;
        as: string | Record<string, any>;
        unmount: boolean;
        static: boolean;
    }, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
export default _default;
