import { PropType } from 'vue';
import { getId } from '../../../helper/IdHelper';
import { default as InfoLabelContent } from '../../../helper/types/InfoLabelContent';
/**
 * https://vue3datepicker.com/
 */
declare const _default: import('vue').DefineComponent<import('vue').ExtractPropTypes<{
    id: {
        type: StringConstructor;
        required: true;
    };
    modelValue: {
        type: (StringConstructor | DateConstructor | {
            (arrayLength: number): (string | Date)[];
            (...items: (string | Date)[]): (string | Date)[];
            new (arrayLength: number): (string | Date)[];
            new (...items: (string | Date)[]): (string | Date)[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T, U>(arrayLike: ArrayLike<T>, mapfn: (v: T, k: number) => U, thisArg?: any): U[];
            from<T>(iterable: Iterable<T> | ArrayLike<T>): T[];
            from<T, U>(iterable: Iterable<T> | ArrayLike<T>, mapfn: (v: T, k: number) => U, thisArg?: any): U[];
            of<T>(...items: T[]): T[];
            fromAsync<T>(iterableOrArrayLike: AsyncIterable<T> | Iterable<T | PromiseLike<T>> | ArrayLike<T | PromiseLike<T>>): Promise<T[]>;
            fromAsync<T, U>(iterableOrArrayLike: AsyncIterable<T> | Iterable<T> | ArrayLike<T>, mapFn: (value: Awaited<T>) => U, thisArg?: any): Promise<Awaited<U>[]>;
            readonly [Symbol.species]: ArrayConstructor;
        })[];
        default: undefined;
    };
    mode: {
        type: PropType<"date" | "time" | "datetime">;
        required: true;
    };
    format: {
        type: StringConstructor;
        required: true;
    };
    maxRange: {
        type: (StringConstructor | NumberConstructor)[];
        default: null;
    };
    range: {
        type: BooleanConstructor;
        default: boolean;
    };
    clearable: {
        type: BooleanConstructor;
        default: boolean;
    };
    multiCalendars: {
        type: (BooleanConstructor | NumberConstructor)[];
        default: boolean;
    };
    label: {
        type: StringConstructor;
        default: string;
    };
    required: {
        type: BooleanConstructor;
        default: boolean;
    };
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    dark: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * smallest possible date. https://developer.mozilla.org/en-US/docs/Web/HTML/Attributes/min
     */
    min: {
        type: (StringConstructor | DateConstructor)[];
        default: string;
    };
    /**
     * largest possible date
     */
    max: {
        type: (StringConstructor | DateConstructor)[];
        default: string;
    };
    autoApply: {
        type: BooleanConstructor;
        default: boolean;
    };
    closeOnAutoApply: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * A small question mark icon will appear, which will display the text when you click on it.
     */
    infoLabelContent: {
        type: PropType<undefined | InfoLabelContent>;
        default: undefined;
    };
}>, {
    dateSelected: (event: Event) => void;
    parsedFormat: import('vue').ComputedRef<string>;
    is24: import('vue').ComputedRef<boolean>;
    value: import('vue').WritableComputedRef<any, any>;
    getId: typeof getId;
}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, "update:modelValue"[], "update:modelValue", import('vue').PublicProps, Readonly<import('vue').ExtractPropTypes<{
    id: {
        type: StringConstructor;
        required: true;
    };
    modelValue: {
        type: (StringConstructor | DateConstructor | {
            (arrayLength: number): (string | Date)[];
            (...items: (string | Date)[]): (string | Date)[];
            new (arrayLength: number): (string | Date)[];
            new (...items: (string | Date)[]): (string | Date)[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T, U>(arrayLike: ArrayLike<T>, mapfn: (v: T, k: number) => U, thisArg?: any): U[];
            from<T>(iterable: Iterable<T> | ArrayLike<T>): T[];
            from<T, U>(iterable: Iterable<T> | ArrayLike<T>, mapfn: (v: T, k: number) => U, thisArg?: any): U[];
            of<T>(...items: T[]): T[];
            fromAsync<T>(iterableOrArrayLike: AsyncIterable<T> | Iterable<T | PromiseLike<T>> | ArrayLike<T | PromiseLike<T>>): Promise<T[]>;
            fromAsync<T, U>(iterableOrArrayLike: AsyncIterable<T> | Iterable<T> | ArrayLike<T>, mapFn: (value: Awaited<T>) => U, thisArg?: any): Promise<Awaited<U>[]>;
            readonly [Symbol.species]: ArrayConstructor;
        })[];
        default: undefined;
    };
    mode: {
        type: PropType<"date" | "time" | "datetime">;
        required: true;
    };
    format: {
        type: StringConstructor;
        required: true;
    };
    maxRange: {
        type: (StringConstructor | NumberConstructor)[];
        default: null;
    };
    range: {
        type: BooleanConstructor;
        default: boolean;
    };
    clearable: {
        type: BooleanConstructor;
        default: boolean;
    };
    multiCalendars: {
        type: (BooleanConstructor | NumberConstructor)[];
        default: boolean;
    };
    label: {
        type: StringConstructor;
        default: string;
    };
    required: {
        type: BooleanConstructor;
        default: boolean;
    };
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    dark: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * smallest possible date. https://developer.mozilla.org/en-US/docs/Web/HTML/Attributes/min
     */
    min: {
        type: (StringConstructor | DateConstructor)[];
        default: string;
    };
    /**
     * largest possible date
     */
    max: {
        type: (StringConstructor | DateConstructor)[];
        default: string;
    };
    autoApply: {
        type: BooleanConstructor;
        default: boolean;
    };
    closeOnAutoApply: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * A small question mark icon will appear, which will display the text when you click on it.
     */
    infoLabelContent: {
        type: PropType<undefined | InfoLabelContent>;
        default: undefined;
    };
}>> & Readonly<{
    "onUpdate:modelValue"?: ((...args: any[]) => any) | undefined;
}>, {
    label: string;
    disabled: boolean;
    required: boolean;
    infoLabelContent: InfoLabelContent | undefined;
    modelValue: string | Date | (string | Date)[];
    clearable: boolean;
    min: string | Date;
    max: string | Date;
    range: boolean;
    multiCalendars: number | boolean;
    dark: boolean;
    autoApply: boolean;
    closeOnAutoApply: boolean;
    maxRange: string | number;
}, {}, {
    InfoLabel: import('vue').DefineComponent<import('vue').ExtractPropTypes<{
        forId: {
            type: StringConstructor;
            required: true;
        };
        disabled: {
            type: BooleanConstructor;
            default: undefined;
        };
        width: {
            type: NumberConstructor;
            default: number;
        };
        infoLabelContent: {
            type: PropType<undefined | InfoLabelContent>;
            default: undefined;
        };
        classLabel: {
            type: StringConstructor;
            default: string;
        };
        innerClass: {
            type: StringConstructor;
            default: string;
        };
    }>, {
        position: import('vue').Ref<string, string>;
        checkDivVisibility: () => void;
        tooltipDiv: import('vue').Ref<HTMLElement | null, HTMLElement | null>;
        myWidth: import('vue').Ref<number, number>;
    }, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {}, string, import('vue').PublicProps, Readonly<import('vue').ExtractPropTypes<{
        forId: {
            type: StringConstructor;
            required: true;
        };
        disabled: {
            type: BooleanConstructor;
            default: undefined;
        };
        width: {
            type: NumberConstructor;
            default: number;
        };
        infoLabelContent: {
            type: PropType<undefined | InfoLabelContent>;
            default: undefined;
        };
        classLabel: {
            type: StringConstructor;
            default: string;
        };
        innerClass: {
            type: StringConstructor;
            default: string;
        };
    }>> & Readonly<{}>, {
        disabled: boolean;
        width: number;
        infoLabelContent: InfoLabelContent | undefined;
        classLabel: string;
        innerClass: string;
    }, {}, {
        BaseIcon: import('vue').DefineComponent<import('vue').ExtractPropTypes<{
            name: {
                type: StringConstructor;
                required: true;
            };
            iconClass: {
                type: StringConstructor;
                default: string;
            };
            size: {
                type: StringConstructor;
                default: string;
            };
            label: {
                type: StringConstructor;
                default: string;
            };
        }>, {
            isLoaded: import('vue').Ref<any, any>;
        }, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {}, string, import('vue').PublicProps, Readonly<import('vue').ExtractPropTypes<{
            name: {
                type: StringConstructor;
                required: true;
            };
            iconClass: {
                type: StringConstructor;
                default: string;
            };
            size: {
                type: StringConstructor;
                default: string;
            };
            label: {
                type: StringConstructor;
                default: string;
            };
        }>> & Readonly<{}>, {
            label: string;
            size: string;
            iconClass: string;
        }, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
        BaseLabel: import('vue').DefineComponent<import('vue').ExtractPropTypes<{
            forId: {
                type: StringConstructor;
                required: true;
            };
            classStyle: {
                type: StringConstructor;
                default: string;
            };
            disabled: {
                type: BooleanConstructor;
                default: undefined;
            };
        }>, {}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {}, string, import('vue').PublicProps, Readonly<import('vue').ExtractPropTypes<{
            forId: {
                type: StringConstructor;
                required: true;
            };
            classStyle: {
                type: StringConstructor;
                default: string;
            };
            disabled: {
                type: BooleanConstructor;
                default: undefined;
            };
        }>> & Readonly<{}>, {
            disabled: boolean;
            classStyle: string;
        }, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
        Popover: import('vue').DefineComponent<{
            as: {
                type: (ObjectConstructor | StringConstructor)[];
                default: string;
            };
        }, () => import('vue').VNode<import('vue').RendererNode, import('vue').RendererElement, {
            [key: string]: any;
        }>, unknown, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, Record<string, any>, string, import('vue').VNodeProps & import('vue').AllowedComponentProps & import('vue').ComponentCustomProps, Readonly<import('vue').ExtractPropTypes<{
            as: {
                type: (ObjectConstructor | StringConstructor)[];
                default: string;
            };
        }>>, {
            as: string | Record<string, any>;
        }, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
        PopoverButton: import('vue').DefineComponent<{
            as: {
                type: (ObjectConstructor | StringConstructor)[];
                default: string;
            };
            disabled: {
                type: BooleanConstructor[];
                default: boolean;
            };
            id: {
                type: StringConstructor;
                default: null;
            };
        }, () => import('vue').VNode<import('vue').RendererNode, import('vue').RendererElement, {
            [key: string]: any;
        }>, unknown, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, Record<string, any>, string, import('vue').VNodeProps & import('vue').AllowedComponentProps & import('vue').ComponentCustomProps, Readonly<import('vue').ExtractPropTypes<{
            as: {
                type: (ObjectConstructor | StringConstructor)[];
                default: string;
            };
            disabled: {
                type: BooleanConstructor[];
                default: boolean;
            };
            id: {
                type: StringConstructor;
                default: null;
            };
        }>>, {
            id: string;
            as: string | Record<string, any>;
            disabled: boolean;
        }, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
        PopoverPanel: import('vue').DefineComponent<{
            as: {
                type: (ObjectConstructor | StringConstructor)[];
                default: string;
            };
            static: {
                type: BooleanConstructor;
                default: boolean;
            };
            unmount: {
                type: BooleanConstructor;
                default: boolean;
            };
            focus: {
                type: BooleanConstructor;
                default: boolean;
            };
            id: {
                type: StringConstructor;
                default: null;
            };
        }, () => import('vue').VNode<import('vue').RendererNode, import('vue').RendererElement, {
            [key: string]: any;
        }> | import('vue').VNode<import('vue').RendererNode, import('vue').RendererElement, {
            [key: string]: any;
        }>[] | null, unknown, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, Record<string, any>, string, import('vue').VNodeProps & import('vue').AllowedComponentProps & import('vue').ComponentCustomProps, Readonly<import('vue').ExtractPropTypes<{
            as: {
                type: (ObjectConstructor | StringConstructor)[];
                default: string;
            };
            static: {
                type: BooleanConstructor;
                default: boolean;
            };
            unmount: {
                type: BooleanConstructor;
                default: boolean;
            };
            focus: {
                type: BooleanConstructor;
                default: boolean;
            };
            id: {
                type: StringConstructor;
                default: null;
            };
        }>>, {
            focus: boolean;
            id: string;
            as: string | Record<string, any>;
            unmount: boolean;
            static: boolean;
        }, {}, {}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
    }, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
    Datepicker: import('vue').DefineComponent<import('@vuepic/vue-datepicker').VueDatePicker, {}, {}, import('vue').ComputedOptions, import('@vuepic/vue-datepicker').PublicMethods, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, import('@vuepic/vue-datepicker').EmitEvents[], import('@vuepic/vue-datepicker').EmitEvents, import('@vuepic/vue-datepicker').VueDatePicker>;
}, {}, string, import('vue').ComponentProvideOptions, true, {}, any>;
export default _default;
